// KunSirka2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <iomanip>

#include "DynFronta.h"

using namespace std;

#define SirkaPole	4
#define VyskaPole	4

struct TahKonem {
	int dx;	// zmena v x
	int dy;	// zmena v y

	TahKonem() { ; }
	TahKonem(int _dx, int _dy) : dx(_dx), dy(_dy) { ; }
	void Nastav(int _dx, int _dy) { dx = _dx; dy = _dy; }
};

TahKonem MozneTahy[8] = { TahKonem(2, 1), TahKonem(1, 2), TahKonem(-1, 2), TahKonem(-2, 1),
TahKonem(-2, -1), TahKonem(-1, -2), TahKonem(1, -2), TahKonem(2, -1) };	// osm moznych tahu konem

int Sachovnice[SirkaPole][VyskaPole];
TahKonem Predchudci[SirkaPole][VyskaPole];

void TiskSachovnice()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			cout << setw(4) << Sachovnice[i][j];
		}
		cout << endl << endl;
	}
}

void VymazSachovnici()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			Sachovnice[i][j] = -1;
		}
	}
}

void ZpetnyPruchod(int _PozX, int _PozY, int _CilX, int _CilY)
{
	int X, NoveX;
	int Y, NoveY;

	// zacneme v cili
	X = _CilX;
	Y = _CilY;

	while((X != _PozX) || (Y != _PozY))
	{
		// a pomoci predchudcu si najdeme cestu
		NoveX = Predchudci[X][Y].dx;
		NoveY = Predchudci[X][Y].dy;

		X = NoveX;
		Y = NoveY;
			
		cout << "Jdi na pole: (" << NoveX << " ; " << NoveY << ")" << endl;
	}

	cout << endl;
}

void NajdiCestu(int _PozX, int _PozY, int _CilX, int _CilY)
{
	int iCislo = 0;	// kolikaty tah konem se pokousime udelat
	int NoveX, NoveY;
	int iTah = 0;	// tahy konem

	CDynFronta<TahKonem> Neprozkoumane;

	Sachovnice[_PozX][_PozY] = iCislo;	// prvni pole znulujeme
	Neprozkoumane.Vloz(TahKonem(_PozX, _PozY));	// a vlozime do fronty

	TahKonem Zkoumany;	// zkoumany tah

	// dokud jsme nenavstivili pole na sachovnici
	while(Sachovnice[_CilX][_CilY] == - 1)
	{
		// vezmeme si pole z fronty
		if(!Neprozkoumane.JePrazdna())
		{
			Neprozkoumane.Vyjmi(Zkoumany);

			iCislo = Sachovnice[Zkoumany.dx][Zkoumany.dy] + 1; // delame dalsi tah v poradi

			// udelame vsechny mozne tahy z tohoto pole
			for(iTah = 0; iTah < 8; iTah++)
			{
				NoveX = Zkoumany.dx + MozneTahy[iTah].dx;
				NoveY = Zkoumany.dy + MozneTahy[iTah].dy;

				// pokud je pole stale na sachovnici
				if((NoveX >= 0) && (NoveX < SirkaPole) && (NoveY >= 0) && (NoveY < VyskaPole))
				{
					if(Sachovnice[NoveX][NoveY] == -1)
					{
						// jeste jsme na tomto poli nebyli, tak si ho oznacime dalsim
						Sachovnice[NoveX][NoveY] = iCislo;
						// pridame si ho ke zkoumani do fronty
						Neprozkoumane.Vloz(TahKonem(NoveX, NoveY));
						// a navic si ulozime predchudce tohoto pole pro zpetny pruchod
						Predchudci[NoveX][NoveY].Nastav(Zkoumany.dx, Zkoumany.dy);
					}
				}
			}
		}
	}

	// mame nalezenou cestu -> udelame zpetny pruchod
	ZpetnyPruchod(_PozX, _PozY, _CilX, _CilY);
}
		
int main(int argc, char* argv[])
{
	int PozX, PozY, CilX, CilY;

	cout << "Zadej x souradnici kone: ";
	cin >> PozX;
	cout << "Zadej y souradnici kone: ";
	cin >> PozY;

	cout << "Zadej x souradnici cile: ";
	cin >> CilX;
	cout << "Zadej y souradnici cile: ";
	cin >> CilY;


	if( ((PozX >= 0) && (PozX < SirkaPole) && (PozY >= 0) && (PozY < VyskaPole)) &&
	    ((CilX >= 0) && (CilX < SirkaPole) && (CilY >= 0) && (CilY < VyskaPole)) )
	{
		VymazSachovnici();

		NajdiCestu(PozX, PozY, CilX, CilY);

		TiskSachovnice();
	}
	else
	{
		cout << endl << "Zadana pozice lezi mimo hraci pole" << endl;
	}

	char c;
	cin >> c;

	return 0;
}


